unit sCustomButton;
(************************************************************************
sStyle components package
Copyright (c) 2002 Serge Goncharov
                            Ukraine, Odessa
                            http://www.geocities.com/sstylish2002/
                            Serge@HyBce.com
 Version:	1.1, 04-02-2002
*************************************************************************)

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, sStyleUtil,
    sMessages, sConst, ExtCtrls, sPanel, sGraphUtils, commctrl, Buttons, Imglist,
    sUtils, ActnList, comctrls, Menus;

type
  TsCustomButton = Class;

  TsButtonActionLink = class(TControlActionLink)
  protected
    FClient: TsCustomButton;
    procedure AssignClient(AClient: TObject); override;
    function IsCheckedLinked: Boolean; override;
    procedure SetChecked(Value: Boolean); override;
    function IsImageIndexLinked: Boolean; override;
    procedure SetImageIndex(Value: Integer); override;
    function IsCaptionLinked: Boolean; override;
    procedure SetCaption(const Value: String); override;
//    function IsHintLinked: Boolean; override;
//    procedure SetHint(const Value: string); override;
  end;

  TsCustomButton = class(TCustomControl)//(TGraphicControl)//
  private
    FShowCaption: boolean;
    FSpacing: integer;
    FMarginH: integer;
    FMarginV: integer;
    FImgWidth: integer;
    FImgHeight: integer;
    FImageIndex : integer;
    FAutoSize: boolean;
    FImageChangeLink: TChangeLink;
    FDropdownMenu: TPopupMenu;
    procedure SetLayout(const Value: TButtonLayout);
    procedure SetBevelWidth(const Value: integer);
    procedure SetSpacing(const Value: integer);
    procedure SetMarginH(const Value: integer);
    procedure SetMarginV(const Value: integer);
    procedure SetImgHeight(const Value: integer);
    procedure SetImgWidth(const Value: integer);
    procedure SetDown(const Value: boolean);
    procedure SetAutoSize(const Value: boolean);
    procedure SetShowCaption(const Value: boolean);
    procedure SetButtonStyle(const Value: TToolButtonStyle);
    procedure SetDropdownMenu(const Value: TPopupMenu);
  protected
    FBevelWidth : integer;
    FButtonStyle : TToolButtonStyle;
    FDown : boolean;
    FLayout : TButtonLayout;
    FsStyle : TsPassiveBGStyle;
    FWallpaperCheck: boolean;
    FDropDowmMenu : TPopupMenu;
    FOldBounds : TRect;
    procedure ActionChange(Sender: TObject; CheckDefaults: Boolean); override;
    procedure DrawCaption;
    function GetActionLinkClass: TControlActionLinkClass; override;
    function GetDown : integer; dynamic;
    function GetImgHeight: integer; dynamic;
    function GetImgWidth: integer; dynamic;
    function GetImgRect: TRect; dynamic;
    function AddedWidth: integer; dynamic;
    procedure AddedPainting; dynamic;
    procedure MouseDown (Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
    procedure MouseUp (Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
    procedure SetImageIndex(const Value: integer);
    procedure WndProc (var Message: TMessage); override;
    procedure WMEraseBkGND (var Message: TWMPaint); message WM_ERASEBKGND;
    procedure WriteText(R : TRect);
  public
    DroppedDown : boolean;
    procedure AdjustSize; override;
    constructor Create (AOwner: TComponent); override;
    destructor Destroy; override;
    procedure Invalidate; override;
    procedure Paint; override;
    procedure DrawContents; dynamic;
    procedure DrawGlyph; dynamic;
    property Down : boolean read FDown write SetDown default False;
    property ImgWidth : integer read FImgWidth write SetImgWidth;
    property ImgHeight : integer read FImgHeight write SetImgHeight;
    property ButtonStyle : TToolButtonStyle read FButtonStyle write SetButtonStyle default tbsButton;
    property DropdownMenu: TPopupMenu read FDropdownMenu write SetDropdownMenu;
  published
    property AutoSize : boolean read FAutoSize write SetAutoSize default False;
    property BevelWidth : integer read FBevelWidth write SetBevelWidth default 1;
    property Layout : TButtonLayout read FLayout write SetLayout;
    property sStyle : TsPassiveBGStyle read FsStyle write FsStyle;
    property WallpaperCheck: boolean read FWallpaperCheck write FWallpaperCheck default False;
    property Action;
    property Align;
    property Anchors;
    property Caption;
    property Constraints;
    property DragCursor;
    property DragKind;
    property DragMode;
    property Enabled;
    property Font;
    property ImageIndex : integer{TImageIndex} read FImageIndex write SetImageIndex default 0;
    property MarginH : integer read FMarginH write SetMarginH default 5;
    property MarginV : integer read FMarginV write SetMarginV default 3;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property ShowCaption: boolean read FShowCaption write SetShowCaption default True;
    property ShowHint;
    property Spacing : integer read FSpacing write SetSpacing default 3;
    property Visible;
    property OnCanResize;
    property OnClick;
    property OnConstrainedResize;
    property OnContextPopup;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDock;
    property OnEndDrag;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnResize;
    property OnStartDock;
    property OnStartDrag;
  end;


  TsSpeedButton = class(TsCustomButton)
  private
    procedure SetImages(const Value: TCustomImageList);
  protected
    FImages : TCustomImageList;
    FImagesHot : TCustomImageList;
    FImagesDisabled : TCustomImageList;
    procedure DrawGlyph; override;
    function GetImageList : TCustomImageList;
    function GetImgHeight: integer; override;
    function GetImgWidth: integer; override;
    function AddedWidth : integer; override;
    procedure ActionChange(Sender: TObject; CheckDefaults: Boolean); override;
    procedure MouseDown (Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
    procedure MouseUp (Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
  public
    constructor Create (AOwner: TComponent); override;
  published
    property ButtonStyle;
    property Down;
    property DropdownMenu;
    property ImagesDisabled : TCustomImageList read FImagesDisabled write FImagesDisabled;
    property ImagesHot : TCustomImageList read FImagesHot write FImagesHot;
    property Images : TCustomImageList read FImages write SetImages;
  end;

  TsColorSelect = class(TsCustomButton)
  private
    FColorValue : TColor;
    FOnChange : TNotifyEvent;
    procedure SetColorValue(const Value: TColor);
    procedure DrawGlyph; override;
    procedure MouseUp (Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
  protected
  public
    constructor Create (AOwner: TComponent); override;
  published
    property ColorValue : TColor read FColorValue write SetColorValue;
    property ImgWidth;
    property ImgHeight;
    property OnChange: TNotifyEvent read FOnChange write FOnChange;
  end;

  TsBitButton = class(TsCustomButton)
  private
  protected
  public
    Glyph : TBitmap;
    NumGlyphs : integer;
    constructor Create (AOwner: TComponent); override;
    destructor Destroy; override;
  published
    property ImgWidth;
    property ImgHeight;
  end;

implementation

var
  MenuVisible : boolean = False;

{ TToolButtonActionLink }

procedure TsButtonActionLink.AssignClient(AClient: TObject);
begin
  inherited AssignClient(AClient);
  FClient := AClient as TsCustomButton;
//  TsCustomButton(AClient).ActionChange(AClient, False);
end;

function TsButtonActionLink.IsCaptionLinked: Boolean;
begin
  Result := inherited IsCaptionLinked and
    (FClient.Caption = (Action as TCustomAction).Caption);
end;

function TsButtonActionLink.IsCheckedLinked: Boolean;
begin
  Result := inherited IsCheckedLinked and
    (FClient.Down = (Action as TCustomAction).Checked);
end;

function TsButtonActionLink.IsImageIndexLinked: Boolean;
begin
  Result := inherited IsImageIndexLinked{ and
    (FClient.ImageIndex = (Action as TCustomAction).ImageIndex)};
end;

procedure TsButtonActionLink.SetCaption(const Value: String);
begin
  if IsCaptionLinked and (FClient.Caption <> Value) then FClient.Caption := Value;
end;

procedure TsButtonActionLink.SetChecked(Value: Boolean);
begin
  if IsCheckedLinked then FClient.Down := Value;
end;

procedure TsButtonActionLink.SetImageIndex(Value: Integer);
begin
  if IsImageIndexLinked then FClient.ImageIndex := Value;
end;

{ TsCustomButton }

procedure TsCustomButton.ActionChange(Sender: TObject;
  CheckDefaults: Boolean);
begin
//  ShowWarning(Bool[integer(CheckDefaults)]);
  inherited ActionChange(Sender, CheckDefaults);
  if not CheckDefaults then begin
    if Caption <> TAction(Action).Caption then begin
      Caption := TAction(Action).Caption;
      Invalidate;
    end;
    if Hint <> TAction(Action).Hint then begin
      Hint := TAction(Action).Hint;
    end;
  end;
end;

constructor TsCustomButton.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  ControlStyle := [csOpaque, csCaptureMouse, csDoubleClicks, csSetCaption];//[csCaptureMouse, csSetCaption, csClickEvents];
  sStyle := TsPassiveBGStyle.Create(TWinControl(Self));
  sStyle.COC := COC_TsCustomButton;
//  sStyle.GroupIndex := 0;
//  sStyle.HotTrack := True;
//  ParentFont := True;
//  sStyle.Painting.Transparency := 50;
  FButtonStyle := tbsButton;
  Height := 22;
  Width := 84;
  FImageIndex := 0;
  FSpacing := 3;
  FMarginH := 5;
  FMarginV := 3;
  FBevelWidth := 1;
  TabStop := False;
//  sStyle.Background.FMode := bgsTransparent;
  FImageChangeLink := TChangeLink.Create;
  FShowCaption := True;
end;

destructor TsCustomButton.Destroy;
begin
  sStyle.Free;
  FreeAndNil(FImageChangeLink);
  inherited;
end;

procedure TsCustomButton.DrawContents;
begin
  case ButtonStyle of
    tbsDivider: begin
      sStyle.PaintBorder(sStyle.FCacheBmp.Canvas.Handle,
                           (Width + BevelWidth) div 2,
                           BevelWidth,
                           (Width + BevelWidth) div 2,
                           Height - BevelWidth * 2,
                           True);

{
      sGraphUtils.Line3D(sStyle.FCacheBmp.Canvas,
                         Point((Width - BevelWidth) div 2, BevelWidth),
                         Point((Width - BevelWidth) div 2, Height - BevelWidth * 2),
                         sStyle.Painting.ColorBorderBottom,
                         sStyle.Painting.ColorBorderTop,
                         BevelWidth);
}

    end;
    tbsSeparator: begin
    end;
    else begin
      DrawGlyph;
      DrawCaption;
      sStyle.PaintBorder(sStyle.FCacheBmp.Canvas.Handle, ClientRect.Left, ClientRect.Top, ClientRect.Right - AddedWidth, ClientRect.Bottom, Down);
    end;
  end;
end;

function TsCustomButton.GetImgWidth: integer;
begin
  Result := ImgWidth;
end;

function TsCustomButton.GetImgHeight: integer;
begin
  Result := ImgHeight;
end;

procedure TsCustomButton.DrawCaption;
var
  IHnd : cardinal;
  IList: TCustomImageList;
  rText : TRect;
  Enbl : boolean;
  GWidth, GHeight : integer;
begin
  GWidth := GetImgWidth;
  GHeight := GetImgHeight;

  Case Layout of
    blGlyphLeft : begin
      RText.Left := GWidth + Spacing;
      RText.Top := 0;
      RText.Right := ClientRect.Right - AddedWidth;
      RText.Bottom := ClientRect.Bottom;
    end;
    blGlyphRight : begin
      RText.Left := 0;
      RText.Top := 0;
      RText.Right := ClientRect.Right - GWidth - Spacing - AddedWidth;
      RText.Bottom := ClientRect.Bottom;
    end;
    blGlyphTop : begin
      RText.Left := 0;
      RText.Top := GHeight + Spacing;
      RText.Right := ClientRect.Right - AddedWidth;
      RText.Bottom := ClientRect.Bottom;
    end;
    blGlyphBottom : begin
      RText.Left := 0;
      RText.Top := 0;
      RText.Right := ClientRect.Right - AddedWidth;
      RText.Bottom := ClientRect.Bottom - GHeight - Spacing;
    end;
  end;
  OffsetRect(RText, GetDown, GetDown);
  WriteText(RText);
end;

procedure TsCustomButton.DrawGlyph;
begin
  sStyle.FCacheBmp.Canvas.Pen.Style := psClear;
  sStyle.FCacheBmp.Canvas.Brush.Color := Color;
  sStyle.FCacheBmp.Canvas.Rectangle(GetImgRect);
end;

function TsCustomButton.GetActionLinkClass: TControlActionLinkClass;
begin
  Result := TsButtonActionLink;
end;

procedure TsCustomButton.Invalidate;
begin
  if Assigned(Parent) and not(csDestroying in ComponentState)
     and not(csLoading in ComponentState) then begin
    AdjustSize;
//    RequestAlign;
  end;
  inherited;
end;

procedure TsCustomButton.MouseDown(Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if (Button = mbLeft) and Enabled and not Down and (ButtonStyle <> tbsDivider) and (ButtonStyle <> tbsSeparator) then begin
    Down := True;
    Repaint;
    inherited MouseDown(Button, Shift, X, Y);
  end;
end;

procedure TsCustomButton.MouseUp(Button: TMouseButton; Shift: TShiftState;
  X, Y: Integer);
begin
  if (Button = mbLeft) and Enabled and (ButtonStyle <> tbsDivider) and (ButtonStyle <> tbsSeparator) then begin
    Down := False;
    Repaint;
    Click;
    inherited;
  end;
end;

procedure TsCustomButton.SetBevelWidth(const Value: integer);
begin
  FBevelWidth := Value;
  Invalidate;
end;

procedure TsCustomButton.SetLayout(const Value: TButtonLayout);
begin
  FLayout := Value;
  Invalidate;
end;

procedure TsCustomButton.SetMarginH(const Value: integer);
begin
  FMarginH := Value;
  Invalidate;
end;

procedure TsCustomButton.SetMarginV(const Value: integer);
begin
  FMarginV := Value;
  Invalidate;
end;

procedure TsCustomButton.SetSpacing(const Value: integer);
begin
  if FSpacing <> Value then begin
    FSpacing := Value;
    Invalidate;
  end;
end;

procedure TsCustomButton.WMEraseBkGND(var Message: TWMPaint);
begin
  Message.Result := 1;
end;

procedure TsCustomButton.SetImageIndex(const Value: integer);//TImageIndex);
begin
  if FImageIndex <> Value then begin
    FImageIndex := Value;
    Invalidate;
  end;
end;

procedure TsCustomButton.WndProc(var Message: TMessage);
begin
  if Message.Msg = CM_TEXTCHANGED then begin
    Invalidate;
  end
  else begin
    sStyle.WndProc(Message);
//    if Message.Result <> 1 then
      inherited;
  end;
end;

procedure TsCustomButton.WriteText(R: TRect);
const
  Alignments: array[TAlignment] of Longint = (DT_LEFT, DT_RIGHT, DT_CENTER);
var
  Flags: Longint;
begin
  if not ShowCaption then Exit;
  sStyle.FCacheBmp.Canvas.Brush.Style := bsClear;
  sStyle.FCacheBmp.Canvas.Font := Font;

  R.Top := ((R.Bottom + R.Top) - sStyle.FCacheBmp.Canvas.TextHeight('W')) div 2;
  R.Bottom := R.Top + sStyle.FCacheBmp.Canvas.TextHeight('W');

  Flags := DT_EXPANDTABS or DT_VCENTER or Alignments[taCenter];
  Flags := DrawTextBiDiModeFlags(Flags);

  if Enabled then begin
    DrawText(sStyle.FCacheBmp.Canvas.Handle, PChar(Caption), -1, R, Flags);
  end
  else begin
    OffsetRect(r, 1, 1);
    sStyle.FCacheBmp.Canvas.Font.Color := clBtnHighlight;
    DrawText(sStyle.FCacheBmp.Canvas.Handle, PChar(Caption), -1, R, Flags);
    OffsetRect(r, -1, -1);
    sStyle.FCacheBmp.Canvas.Font.Color := clBtnShadow;
    DrawText(sStyle.FCacheBmp.Canvas.Handle, PChar(Caption), -1, R, Flags);
  end;
end;

function TsCustomButton.GetImgRect: TRect;
var
  GWidth, GHeight, x, y : integer;
begin
  GWidth := GetImgWidth;
  GHeight := GetImgHeight;
  Case Layout of
    blGlyphLeft : begin
      x := MarginH;
      y := (Height - GHeight) div 2;
    end;
    blGlyphRight : begin
      x := Width - MarginH - GWidth - AddedWidth;
      y := (Height - GHeight) div 2;
    end;
    blGlyphTop : begin
      x := (Width - AddedWidth - GWidth) div 2;
      if ShowCaption then begin
        y := (Height - GHeight - Spacing - Canvas.TextHeight('W')) div 2;
      end
      else begin
        y := (Height - GHeight) div 2;
      end;
    end;
    blGlyphBottom : begin
      x := (Width - AddedWidth - GWidth) div 2;
      if ShowCaption then begin
        y := Height - (Height - GHeight - Spacing - Canvas.TextHeight('W')) div 2 - GHeight;
      end
      else begin
        y := Height - (Height - GHeight) div 2 - GHeight;
      end;
    end;
  end;
  Result := Rect(x, y, x + GWidth, y + GHeight);
  OffsetRect(Result, GetDown, GetDown);
end;

procedure TsCustomButton.SetImgHeight(const Value: integer);
begin
  FImgHeight := Value;
  Invalidate;
end;

procedure TsCustomButton.SetImgWidth(const Value: integer);
begin
  FImgWidth := Value;
  Invalidate;
end;

procedure TsCustomButton.AdjustSize;
var
  IWidth, IHeight, NewWidth, NewHeight, NewTop, NewLeft : integer;
  ToolBar : TsToolBar;
begin
  if Down then exit;
  if (csLoading in ComponentState) then exit;

  NewLeft   := Left;
  NewTop    := Top;
  NewHeight := Height;
  NewWidth  := Width;
  if AutoSize and not ((GetImgHeight = 0) and not ShowCaption) then begin
    Case ButtonStyle of
      tbsSeparator: begin
        NewHeight :=GetImgHeight + MarginV * 2 + BevelWidth * 2;
        NewWidth  := Height + MarginH * 2 + BevelWidth * 2;
      end;
      tbsDivider: begin
        NewHeight := GetImgHeight + MarginV * 2 + BevelWidth * 2;
        NewWidth  := BevelWidth * 2 + 4;
      end;
      else begin
        // Calc constraints
        IHeight := GetImgHeight;
        Inc(IHeight, BevelWidth * 2);

        IWidth := GetImgWidth;
        Inc(IWidth, BevelWidth * 2);

        // With text
        if ShowCaption then begin
          Case Layout of
            blGlyphLeft, blGlyphRight : begin
              NewWidth := IWidth + Spacing + Canvas.TextWidth(Caption) + MarginH * 2;
              NewHeight := Maxi(IHeight, Canvas.TextHeight('W')) + MarginV * 2;
            end;
            blGlyphTop, blGlyphBottom : begin
              NewWidth := Maxi(IWidth, Canvas.TextWidth(Caption)) + MarginH * 2;
              NewHeight := IHeight + Spacing + Canvas.TextHeight('W') + MarginV * 2;
            end;
          end;
        end //without text
        else begin
          NewWidth := IWidth + MarginH * 2;
          NewHeight := IHeight + MarginV * 2;
        end;

        // Added width - for DropDown button, etc.
        Inc(NewWidth, AddedWidth);

        if (Parent is TsToolBar) and TsToolBar(Parent).Autosize then begin
          ToolBar := TsToolBar(Parent);
        end else ToolBar := nil;
        case Align of
          alNone: begin
          end;
          alLeft, alRight: begin
            if Assigned(ToolBar) then begin
              NewTop := iffi(ToolBar.BevelOuter <> bvNone, ToolBar.BevelWidth, 0) + ToolBar.BorderWidth;
            end;
          end;
          alTop, alBottom: begin
            if Assigned(ToolBar) then begin
              NewLeft := iffi(ToolBar.BevelOuter <> bvNone, ToolBar.BevelWidth, 0) +ToolBar.BorderWidth;
            end;
          end;
        end;
      end;
    end;
  end
  else begin
    if Parent is TsToolBar then begin
    end;
  end;
  SetBounds(NewLeft, NewTop, NewWidth, NewHeight);
{  SetWindowPos(Handle, 0, NewLeft, NewTop, NewWidth, NewHeight,
                             SWP_NOACTIVATE or
                             SWP_NOMOVE or
                             SWP_NOCOPYBITS or
                             SWP_NOOWNERZORDER or
                             SWP_NOREDRAW or
                             SWP_NOSENDCHANGING	or
                             SWP_NOZORDER);}
//  if Align <> alNone then RequestAlign;
end;

function TsCustomButton.GetDown: integer;
begin
  if (BevelWidth = 0) and FDown then
    Result := Integer(FDown) * (BevelWidth + 1)
  else
    Result := Integer(FDown) * (BevelWidth);
end;

procedure TsCustomButton.SetDown(const Value: boolean);
begin
  if FDown <> Value then begin
    FDown := Value;
    if Parent is TsToolBar then TsToolBar(Parent).DontAutoSize := Value;
//    sStyle.BeginDrawing;
    if sStyle.Shadow.Enabled and assigned(sSTyle.Shadow.FLabel) then begin
      sStyle.Shadow.FLabel.Visible := not Value;
{      if Value then begin
        Left := Left + sStyle.Shadow.Offset div 3;
        Top  := Top + sStyle.Shadow.Offset div 3;
      end
      else begin
        Left := Left - sStyle.Shadow.Offset div 3;
        Top  := Top - sStyle.Shadow.Offset div 3;
      end;}
    end
    else begin
{      if Value then begin
        Left := Left + 1;
        Top  := Top  + 1;
      end
      else begin
        Left := Left - 1;
        Top  := Top  - 1;
      end;}
    end;
//    sStyle.EndDrawing;
  end;
end;

{
function TsCustomButton.DoCanResize(var NewWidth, NewHeight: Integer): Boolean;
begin
  Result := False;
end;
}
procedure TsCustomButton.SetAutoSize(const Value: boolean);
begin
  if FAutoSize <> Value then begin
    FAutoSize := Value;
    invalidate;
  end;
end;

procedure TsCustomButton.SetShowCaption(const Value: boolean);
begin
  if FShowCaption <> Value then begin
    FShowCaption := Value;
    Invalidate;
  end;
end;

procedure TsCustomButton.SetButtonStyle(const Value: TToolButtonStyle);
begin
  if FButtonStyle <> Value then begin
    FButtonStyle := Value;
    Invalidate;
  end;
end;

procedure TsCustomButton.SetDropdownMenu(const Value: TPopupMenu);
begin
  if Value <> FDropdownMenu then begin
    FDropdownMenu := Value;
    if Value <> nil then Value.FreeNotification(Self);
  end;
end;

function TsCustomButton.AddedWidth: integer;
begin
  Result := 0;
end;

procedure TsCustomButton.AddedPainting;
  var
    Offset : integer;
  procedure PaintButton(R : TRect);
  var
    x, y, i: Integer;
    procedure PolyDown;
    begin
      sStyle.FCacheBmp.Canvas.Polygon([Point(x + 3, y + 3), Point(x + 9, y + 3), Point(x + 6, y)])
    end;
    procedure PolyUp;
    begin
      sStyle.FCacheBmp.Canvas.Polygon([Point(x + 3, y), Point(x + 9, y), Point(x + 6, y + 3)]);
    end;
  begin
    i := 1;
    x := (R.Right - R.Left) div 2 - 6 + R.Left + Offset;
    y := (R.Bottom - R.Top) div 2 - 1 + R.Top + Offset;
    sStyle.PaintBorder(sStyle.FCacheBmp.Canvas.Handle, R.Left, R.Top, R.Right, R.Bottom, Down or DroppedDown);

    if Enabled then begin
      sStyle.FCacheBmp.Canvas.Brush.Color := clBlack;
      sStyle.FCacheBmp.Canvas.Pen.Color := clBlack;
      PolyUp;
    end
    else begin
      sStyle.FCacheBmp.Canvas.Brush.Color := clWhite;
      sStyle.FCacheBmp.Canvas.Pen.Color := clWhite;
      Inc(x); Inc(y);
      PolyUp;

      Dec(x); Dec(y);
      sStyle.FCacheBmp.Canvas.Brush.Color := clGray;
      sStyle.FCacheBmp.Canvas.Pen.Color := clGray;
      PolyUp;
    end;
  end;
begin
  if ButtonStyle = tbsDropDown then begin
    offset := Integer(FDown or DroppedDown) * (BevelWidth);
    PaintButton(Rect(Width - AddedWidth,
                     0 + Integer(DroppedDown) * (BevelWidth),
                     Width,
                     Height));
  end;
end;

procedure TsCustomButton.Paint;
var
  aRect : TRect;
begin
  if not sStyle.FDrawingStop and not(csDestroying in ComponentState)
                             and not(csLoading in ComponentState)
                             and not(csCreating in ControlState)
                             and Assigned(Parent)
                             then begin
    aRect := ClientRect;
    sStyle.FCacheBmp.Height := aRect.Bottom - aRect.Top + 1;
    sStyle.FCacheBmp.Width := aRect.Right - aRect.Left + 1;
    OffsetRect(aRect, GetDown, GetDown);
    Color := sStyle.GetActiveColor;
    sStyle.FCacheBmp.Canvas.Pen.Style := psClear;
    sStyle.FCacheBmp.Canvas.Brush.Style := bsSolid;
    sStyle.FCacheBmp.Canvas.Brush.Color := Color;
    if sStyle.Flat then begin
      case ButtonStyle of
        tbsDivider, tbsSeparator : begin
          if sStyle.GetParentCache <> nil then begin
            FadeRect(sStyle.GetParentCache.Canvas, Rect(Left, Top, Left + Width, Top + Height), sStyle.FCacheBmp.Canvas, Point(0, 0), 100, sStyle.GetActiveColor, 0, ssRectangle);
          end
          else begin
Alert;
          end;
        end;
        else begin
          case sStyle.Background.Mode of
            bgsNone: begin
              sStyle.FCacheBmp.Canvas.Rectangle(aRect);
            end;
            bgsTransparent: begin
              if sStyle.Painting.Transparency = 0 then begin
                sStyle.FCacheBmp.Canvas.FillRect(aRect);
              end
              else begin
                OffsetRect(aRect, - GetDown, - GetDown);
                if sStyle.GetParentCache <> nil then begin
                  if sStyle.Shadow.Enabled and assigned(sStyle.Shadow.FLabel) and sStyle.Shadow.FLabel.Visible then begin
                    FadeRect(sStyle.GetParentCache.Canvas, Rect(Left, Top, Left + Width, Top + Height), sStyle.FCacheBmp.Canvas, Point(0, 0), 100, sStyle.GetActiveColor, 0, ssRectangle);
                    FadeRect(sStyle.FCacheBmp.Canvas, Rect(sStyle.Shadow.Offset, sStyle.Shadow.Offset, Width + sStyle.Shadow.Offset, Height + sStyle.Shadow.Offset), sStyle.FCacheBmp.Canvas, Point(sStyle.Shadow.Offset, sStyle.Shadow.Offset), sStyle.Shadow.Transparency, sStyle.Shadow.Color, sStyle.Shadow.Blur, ssRectangle);
                    FadeRect(sStyle.FCacheBmp.Canvas, Rect(0, 0, Width, Height), sStyle.FCacheBmp.Canvas, Point(0, 0), sStyle.Painting.Transparency, sStyle.GetActiveColor, 0, ssRectangle);
                  end
                  else begin
                    FadeRect(sStyle.GetParentCache.Canvas, Rect(Left, Top, Left + Width, Top + Height), sStyle.FCacheBmp.Canvas, Point(0, 0), iffi(sstyle.FMouseAbove and (msColor in sStyle.Selection.Mode), sStyle.Painting.Transparency, 100) , sStyle.GetActiveColor, 0, ssRectangle);
                  end;
                end
                else begin
                  sStyle.FCacheBmp.Canvas.FillRect(aRect);
                end;
              end;
            end;
            bgsImage: begin
              if Assigned(sStyle.Background.Image) and Assigned(sStyle.Background.Image.Graphic) and (sStyle.Background.Image.Width <> 0) and (sStyle.Background.Image.Height <> 0) then begin
                TileBitmap(sStyle.FCacheBmp.Canvas, aRect, sStyle.Background.Image.Graphic);
              end;
            end;
            bgsGradient: begin
              case sStyle.Background.Gradient.Layout of
                gtTopBottom, gtLeftRight : begin
                  GradientBmp(sStyle.FCacheBmp, ClientRect, sStyle.Background.Gradient.Color1, sStyle.Background.Gradient.Color2, sStyle.Background.Gradient.Layout);
                end;
              end;
            end;
          end;
        end;
      end;
    end
    else begin
      sStyle.FCacheBmp.Canvas.Rectangle(Rect(0, 0, sStyle.FCacheBmp.Width, sStyle.FCacheBmp.Height));
    end;
    DrawContents;

    AddedPainting;
    aRect := ClientRect;//PS.rcPaint;
    sStyle.CopyFromCache(Canvas.Handle, aRect.Left, aRect.Top, aRect.Right, aRect.Bottom);
  end;
end;

{ TsSpeedButton }

constructor TsSpeedButton.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  sStyle.COC := COC_TsSpeedButton;
  DroppedDown := False;
end;

function TsSpeedButton.GetImageList : TCustomImageList;
begin
  Result := Images;
  if Enabled then begin
    if sStyle.FMouseAbove or not sStyle.HotTrack then begin
      Result := TCustomImageList(iffo(Assigned(ImagesHot), ImagesHot, Images));
    end
    else begin
      Result := Images;
    end;
  end
  else begin
      Result := TCustomImageList(iffo(Assigned(ImagesDisabled), ImagesDisabled, Images));
  end;
end;

function TsSpeedButton.GetImgHeight: integer;
begin
  if GetImageList <> nil then begin
    Result := GetImageList.Height;
  end
  else begin
    Result := 0;
  end
end;

function TsSpeedButton.GetImgWidth: integer;
begin
  if GetImageList <> nil then begin
    Result := GetImageList.Width;
  end
  else begin
    Result := 0;
  end
end;

procedure TsSpeedButton.SetImages(const Value: TCustomImageList);
begin
  FImages := Value;
  Invalidate;
end;

procedure TsSpeedButton.DrawGlyph;
var
  IRect : TRect;
  IList: TCustomImageList;
  Enbl : boolean;
begin
  IList := GetImageList;
  Enbl := Enabled or (IList = ImagesDisabled);
  IRect := GetImgRect;
  
  if Assigned(IList) and (ImageIndex > -1) then begin
    IList.Draw(sStyle.FCacheBmp.Canvas, IRect.Left, IRect.Top, ImageIndex, Enbl);
  end;
end;

procedure TsSpeedButton.ActionChange(Sender: TObject;
  CheckDefaults: Boolean);
begin
  if not Assigned(Images) and Assigned(TAction(Action).ActionList.Images) then begin
    Images := TAction(Action).ActionList.Images;
  end;
  if ImageIndex <> TAction(Action).ImageIndex then begin
    ImageIndex := TAction(Action).ImageIndex;
  end;
  inherited;
end;

function TsSpeedButton.AddedWidth: integer;
begin
  if ButtonStyle = tbsDropDown then begin
    Result := BevelWidth * 2 + 16;
  end
  else Result := 0;
end;

procedure TsSpeedButton.MouseDown(Button: TMouseButton; Shift: TShiftState;
  X, Y: Integer);
var
  p : TPoint;
begin
  if (X > Width - AddedWidth) and Assigned(DropDownMenu) then begin
    if (Button = mbLeft) and Enabled then begin
      if not MenuVisible then begin
        MenuVisible := True;
        DroppedDown := True;
        p.x := Left; p.y := Top;
        p := ClientToScreen(Point(0, 0));
        DropDownMenu.Popup(p.X, p.Y + Height + 1);
        Repaint;
//        sStyle.FMouseAbove := False;
        MenuVisible := False;
      end;
      DroppedDown := False;
      Repaint;
    end;
  end
  else begin
    DroppedDown := False;
    Repaint;
    inherited;
  end;
end;

procedure TsSpeedButton.MouseUp(Button: TMouseButton; Shift: TShiftState;
  X, Y: Integer);
begin
  if not DroppedDown then inherited;
end;

{ TsColorSelect }

Constructor TsColorSelect.Create(AOwner: TComponent);
begin
  inherited;
  sStyle.COC := COC_TsColorSelect;
  FImgHeight := 16;
  FImgWidth := 52;
  Height := 28;
  Width := 135
end;

procedure TsColorSelect.DrawGlyph;
begin
  sStyle.FCacheBmp.Canvas.Pen.Style := psClear;
  sStyle.FCacheBmp.Canvas.Brush.Color := ColorValue;
  sStyle.FCacheBmp.Canvas.Rectangle(GetImgRect);
end;

procedure TsColorSelect.MouseUp(Button: TMouseButton; Shift: TShiftState;
  X, Y: Integer);
var
  cd : TColorDialog;
begin
  if PtInRect(ClientRect, Point(x, y)) then begin
    cd := TColorDialog.Create(Self);
    cd.Color := ColorValue;
    if cd.Execute then begin
      ColorValue := cd.Color;
      if Assigned(FOnChange) then FOnChange(Self);
    end;
    cd.Free;
  end;
  inherited MouseUp(Button, Shift, X, Y);
end;

procedure TsColorSelect.SetColorValue(const Value: TColor);
begin
  FColorValue := Value;
  Invalidate;
end;

{ TsBitButton }

constructor TsBitButton.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  sStyle.COC := COC_TsBitButton;
  Glyph := TBitmap.Create;
end;

destructor TsBitButton.Destroy;
begin
  FreeAndNil(Glyph);
  inherited Destroy;
end;

end.
