unit sDBMemo;
(************************************************************************
sStyle components package 
Copyright (c) 2002 Serge Goncharov. All rights reserved.
                            Ukraine, Odessa
                            http://www.geocities.com/sstylish2002/
                            Serge@HyBce.com
 Version:	1.2, 24-02-2002
*************************************************************************)

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, DBCtrls, sStyleUtil;

type
  TsDBMemo = class(TDBMemo)
  private
    { Private declarations }
    procedure WMNCCalcSize (var Message: TWMNCCalcSize); message WM_NCCALCSIZE;
    procedure WMNCPaint (var Message: TMessage); message WM_NCPAINT;
  protected
    { Protected declarations }
    FsStyle : TsStyleDB;
    procedure WndProc (var Message: TMessage); override;
  public
    { Public declarations }
    LastControl : boolean;
    constructor Create(AOwner:TComponent); override;
    procedure Invalidate; override;
  published
    { Published declarations }
    property sStyle:TsStyleDB read FsStyle write FsStyle;
  end;

implementation

constructor TsDBMemo.Create(AOwner:TComponent);
begin
  inherited Create(AOwner);
  sStyle := TsStyleDB.Create(Self);
  OnKeyDown := sStyle.onKeyDown;
  ParentColor := False;
end;

procedure TsDBMemo.WMNCCalcSize(var Message: TWMNCCalcSize);
begin
  inherited;
  if sStyle.Flat then begin
    InflateRect(Message.CalcSize_Params^.rgrc[0], -3, -3);
  end;
end;

procedure TsDBMemo.WMNCPaint(var Message: TMessage);
begin
  inherited;
  sStyle.RedrawBorder;
end;

procedure TsDBMemo.Invalidate;
begin
  if not sStyle.FDrawingStop then begin
    Color := sStyle.GetActiveColor;
    if sStyle.Flat then begin
      BorderStyle := bsNone;
      if Assigned(Parent) then sStyle.RedrawBorder;
    end
    else begin
      BorderStyle := bsSingle;
    end;
    inherited;
  end;
end;

procedure TsDBMemo.WndProc(var Message: TMessage);
begin
   sStyle.WndProc(Message);
   inherited;
end;
end.
